unit FavUnit;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,
  CE_Unit, ReuUnit;

type
  TFavForm = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    ListBox1: TListBox;
    RemoveBtn: TBitBtn;
    OrderBtn: TBitBtn;
    AddBtn: TBitBtn;
    OpenDlg: TOpenDialog;
    HelpBtn: TBitBtn;
    procedure AddBtnClick(Sender: TObject);
    procedure OrderBtnClick(Sender: TObject);
    procedure RemoveBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1Enter(Sender: TObject);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    procedure EnableAll;
  public
    { Public declarations }
  end;

var
  FavForm: TFavForm;

implementation

uses MainUnit, OrderUnit;

{$R *.DFM}

procedure TFavForm.EnableAll;
begin
  OrderBtn.Enabled := ListBox1.Items.Count > 1;
  RemoveBtn.Enabled := ListBox1.SelCount > 0;
end;

procedure TFavForm.AddBtnClick(Sender: TObject);
var i : byte;
begin
  if ListBox1.Items.Count > 0 then
    OpenDlg.InitialDir := ExtractFilePath (ListBox1.Items[ListBox1.Items.Count - 1]);

  if OpenDlg.InitialDir = '' then
    if MainForm.FilesOpen > 0 then
      OpenDlg.InitialDir := ExtractFilePath (MainForm.FileName);

  if not OpenDlg.Execute then exit;

  i := 0;
  while i < OpenDlg.Files.Count do
    if not MainForm.CanAddTo (OpenDlg.Files[i]) then
      OpenDlg.Files.Delete (i)
    else
      if ListBox1.Items.IndexOf (OpenDlg.Files[i]) >= 0 then
        if MessageDlg ('File "' + OpenDlg.Files[i] + '" is already in favorites.  Do you wish to add it again?',
                       mtConfirmation, [mbYes, mbNo], 0) = mrNo then
          OpenDlg.Files.Delete (i)
        else
          inc (i)
      else
        inc (i);

  if OpenDlg.Files.Count = 0 then exit;

  ListBox1.Items.AddStrings (OpenDlg.Files);
  EnableAll;
end;

procedure TFavForm.OrderBtnClick(Sender: TObject);
begin
  OrderForm.ListBox1.Items.Assign (ListBox1.Items);
  OrderForm.MainItem := -1;

  if OrderForm.ShowModal = mrCancel then exit;

  ListBox1.Items.Assign (OrderForm.ListBox1.Items);

  EnableAll;
end;

procedure TFavForm.RemoveBtnClick(Sender: TObject);
var i : byte;
begin
  i := ListBox1.Items.Count;
  while (i > 0) do begin
    dec (i);
    if ListBox1.Selected [i] then
      ListBox1.Items.Delete (i);
  end;

  EnableAll;
end;

procedure TFavForm.OKBtnClick(Sender: TObject);
var i : byte;
begin
  with MainForm.FileFavoritesMnu do
    while Count > 0 do
      Delete (0);

  if ListBox1.Items.Count > 0 then
    for i := 0 to ListBox1.Items.Count - 1 do
      if not MainForm.AddToFav (ListBox1.Items[i]) then break;
end;

procedure TFavForm.FormShow(Sender: TObject);
var i : byte;
begin
  ListBox1.Clear;
  with MainForm.FileFavoritesMnu do
    if Count > 0 then
      for i := 0 to Count - 1 do
        ListBox1.Items.Add (CapToStr (Items[i].Caption));

  OpenDlg.Filter := MainForm.OpenDlg.Filter;
  EnableAll;
end;

procedure TFavForm.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DELETE)
  and RemoveBtn.Enabled then
    RemoveBtn.Click;
end;

procedure TFavForm.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  EnableAll;
end;

procedure TFavForm.ListBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  EnableAll;
end;

procedure TFavForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F1 then HelpBtn.Click;
end;

procedure TFavForm.ListBox1Enter(Sender: TObject);
begin
  ListBox1.Tag := -1;
end;

procedure TFavForm.ListBox1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  ListBoxPosToHint(ListBox1, Application, X, Y);
end;

end.

