unit RecentUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Spin, CE_Unit, ReuUnit;

type
  TRecentForm = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    RemoveBtn: TBitBtn;
    OrderBtn: TBitBtn;
    GroupBox1: TGroupBox;
    MaxRecentSE: TSpinEdit;
    Label1: TLabel;
    RecentCB: TGroupBox;
    ListBox1: TListBox;
    procedure FormShow(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OrderBtnClick(Sender: TObject);
    procedure RemoveBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure MaxRecentSEKeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1Enter(Sender: TObject);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    procedure EnableAll;
    procedure UpdateRecentLab;
  public
    { Public declarations }
  end;

var
  RecentForm: TRecentForm;

implementation

uses MainUnit, OrderUnit;

{$R *.DFM}

procedure TRecentForm.EnableAll;
begin
  OrderBtn.Enabled := ListBox1.Items.Count > 1;
  RemoveBtn.Enabled := ListBox1.SelCount > 0;
end;

procedure TRecentForm.UpdateRecentLab;
begin
  RecentCB.Caption := '(' + IntToStr (ListBox1.Items.Count)
    + ')' + ' &Files in Recent Menu';
end;

procedure TRecentForm.FormShow(Sender: TObject);
var i : cardinal;
begin
  MaxRecentSE.Value := MainForm.MaxRecentNum;

  ListBox1.Clear;
  with MainForm.FileRecentMnu do
    if Count > 0 then
      for i := 0 to Count - 1 do
        ListBox1.Items.Add (CapToStr (Items[i].Caption));

  UpdateRecentLab;
  RecentCB.SetFocus;
end;

procedure TRecentForm.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DELETE)
  and RemoveBtn.Enabled then
    RemoveBtn.Click;
end;

procedure TRecentForm.ListBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  EnableAll;
end;

procedure TRecentForm.ListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  EnableAll;
end;

procedure TRecentForm.OrderBtnClick(Sender: TObject);
begin
  OrderForm.ListBox1.Items.Assign (ListBox1.Items);
  OrderForm.MainItem := -1;

  if OrderForm.ShowModal = mrCancel then exit;

  ListBox1.Items.Assign (OrderForm.ListBox1.Items);

  EnableAll;
end;

procedure TRecentForm.RemoveBtnClick(Sender: TObject);
var i : byte;
begin
  i := ListBox1.Items.Count;
  while (i > 0) do begin
    dec (i);
    if ListBox1.Selected [i] then
      ListBox1.Items.Delete (i);
  end;

  EnableAll;
  UpdateRecentLab;
end;

procedure TRecentForm.OKBtnClick(Sender: TObject);
var i : byte;
begin
  Screen.Cursor := crHourGlass;
  MainForm.MaxRecentNum := MaxRecentSE.Value;

  with MainForm.FileRecentMnu do
    while Count > 0 do
      Delete (0);

  i := ListBox1.Items.Count;
  while i > 0 do begin
    dec (i);
    if not MainForm.AddToRecent (ListBox1.Items[i], false) then break;
  end;
  Screen.Cursor := crDefault;
end;

procedure TRecentForm.MaxRecentSEKeyPress(Sender: TObject; var Key: Char);
begin
  ValidateKey (Key);
end;

procedure TRecentForm.ListBox1Enter(Sender: TObject);
begin
  ListBox1.Tag := -1;
end;

procedure TRecentForm.ListBox1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  ListBoxPosToHint(ListBox1, Application, X, Y);
end;

end.
