unit SaveModifiedUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ReuUnit;

type
  TSaveModifiedForm = class(TForm)
    GroupBox1: TGroupBox;
    FilesLB: TListBox;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    SaveNoneBtn: TBitBtn;
    procedure SaveNoneBtnClick(Sender: TObject);
    procedure FilesLBEnter(Sender: TObject);
    procedure FilesLBMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public
    FileNums : TList;
    procedure SetSelectAll(value : boolean);
  end;

var
  SaveModifiedForm: TSaveModifiedForm;

implementation

uses MainUnit;

{$R *.DFM}

procedure TSaveModifiedForm.SetSelectAll(value : boolean);
var i : integer;
begin
  with FilesLB do
    with Items do
      if Count = 0 then
        exit
      else
        for i := 0 to Count - 1 do
          Selected[i] := value;
end;

procedure TSaveModifiedForm.SaveNoneBtnClick(Sender: TObject);
begin
  SetSelectAll(false);
  OKBtn.Click;
end;

procedure TSaveModifiedForm.FilesLBEnter(Sender: TObject);
begin
  FilesLB.Tag := -1;//used as last item index for FilesLB
end;

procedure TSaveModifiedForm.FilesLBMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  ListBoxPosToHint(FilesLB, Application, X, Y);
end;

procedure TSaveModifiedForm.OKBtnClick(Sender: TObject);
var i : integer;
begin
  if FileNums.Count > 0 then
    for i := 0 to FileNums.Count - 1 do
      if FilesLB.Selected[i] then
        MainForm.SaveChanges(integer(FileNums[i]^), false);
end;

procedure TSaveModifiedForm.FormShow(Sender: TObject);
var i, j : integer;
begin
  FilesLB.Clear;
  if FileNums.Count > 0 then
    for i := 0 to FileNums.Count - 1 do begin
      j := integer(FileNums[i]^);
      if j = 0 then
        FilesLB.Items.Add(MainForm.FileName)
      else
        FilesLB.Items.Add(MainForm.Files[j]^.FileName);
    end;

  SetSelectAll(true);
  FilesLB.SetFocus;
end;

procedure TSaveModifiedForm.FormCreate(Sender: TObject);
begin
  FileNums := TList.Create;
end;

procedure TSaveModifiedForm.FormDestroy(Sender: TObject);
begin
  FileNums.Free;
end;

end.
